/*************************************************************************
 *                                                                       *
 * This is free software; you can redistribute it and/or modify          *
 * it under the terms of the GNU General Public License as published by  *
 * the Free Software Foundation; either version 2 of the License, or     *
 * at your option) any later version.                                    *
 *                                                                       *
 * This program is distributed in the hope that it will be useful,       *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 * GNU General Public License for more details.                          *
 *                                                                       *
 * You should have received a copy of the GNU General Public License     *
 * along with Foobar; if not, write to:                                  *
 *                   Free Software Foundation, Inc.                      *
 *                   59 Temple Place                                     *
 *                   Suite 330                                           *
 *                   Boston, MA  02111-1307                              *
 *                   USA                                                 *
 *************************************************************************/


#include <stdio.h>


#define CFG_FILENAME_LEN 512


struct cmdline_struct {
   int  verbose;
   int  showhelp;
   int  board_number;
   int  run_detection;
   int  no_program;
   int  get_current;
   char ledbytes[2];
};

//static const char *HELP_FLAG1    = "-h";
//static const char *HELP_FLAG2    = "--help";
#define HELP_FLAG1     "-h"
#define HELP_FLAG2     "--help"

#define VERBOSE_FLAG1  "-v"
#define VERBOSE_FLAG2  "--verbose"

#define DETECT_FLAG1   "-d"
#define DETECT_FLAG2   "--detect"

#define NO_PGM_FLAG1   "-n"
#define NO_PGM_FLAG2   "--no_program"

#define QUIET_FLAG1    "-q"
#define QUIET_FLAG2    "--quiet"

/* Set all LEDs on */
#define ALLON_FLAG1    "-a"
#define ALLON_FLAG2    "--allon"

/* Set all LEDs off */
#define ALLOFF_FLAG1   "-f"
#define ALLOFF_FLAG2   "--alloff"

/* Set single LED value */
#define LED_FLAG1      "-l"
#define LED_FLAG2      "--led"

/* Set all 16 LEDs using 16-bit hex value */
#define STATE_FLAG1    "-s"
#define STATE_FLAG2    "--state"

/* Get current LED state */
#define CURRENT_FLAG1  "-c"
#define CURRENT_FLAG2  "--current"

/* specify the board to use (defaults to 0, the 1st) */
#define BOARD_FLAG1    "-b"
#define BOARD_FLAG2    "--board"

static const char LED_BYTE_ALL_ON  = 0xff;
static const char LED_BYTE_ALL_OFF = 0x0;

#define BYTE1_LED_INDEX_START   1
#define BYTE1_LED_INDEX_END     8
#define BYTE2_LED_INDEX_START   9
#define BYTE2_LED_INDEX_END     16

#define LED_INDEX_START         BYTE1_LED_INDEX_START
#define LED_INDEX_END           BYTE2_LED_INDEX_END

int parse_cmdline(int argc, char **argv, struct cmdline_struct *settings);
void cmdline_ShowUsage(void);
