#!/usr/bin/python

import pacdrive
import time

# Creates an object using either the pacdrive program or libhid directly

# Without argument, tries to use libhid and 
# falls back to external prgram if libhid can't be found
#pd = pacdrive.pacdrive()

# To try to force libhid, specify interface "libhid".  Will fall
# back to external if libhid can't be found
#pd = pacdrive.pacdrive("libhid")

# This form means use the external pacdrive program
# NOTE: this is the only tested form right now
pd = pacdrive.pacdrive("external")

if pd.init() < 0:
    print "Error: init failed"
    exit

count = pd.get_count()
str = "Found %d Pac-Drive" % count
if count != 1:
    str += "s"
print str

board = count - 1

# All LEDs off
print "All LEDs off"
val = pd.set_led_state(0, board)
#print "set_led_state returned: " + `val`
if val < 0:
    print "Set led failed"
    exit

time.sleep(1)
print "All LEDs on"
# All LEDs on
if pd.set_led_state(0xffff, board) < 0:
    print "Set led failed"
    exit

time.sleep(1)
print "ONLY LED 8 on"
if pd.set_led_state(0x0080, board) < 0:
    print "Set led failed"
    exit

time.sleep(1)
print "LED 8 and 9 on"
if pd.set_single_led(9, 1, board) < 0:
    print "Set single led failed"
    exit
    
# Free up memory, etc
pd.cleanup()
